/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 11.4 EDK_LS4.68
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    E:\Projekti\CAMOS\EDK\1st_system_v1\
 */


// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"

#include "mb_interface.h"

#include "stdio.h"

#include "xutil.h"

//====================================================

   /* Testing MPMC Memory (MCB)*/
   void memtest(u8 cntrl){
		
      XStatus status;
		u32 memaddr;
		if (cntrl==1) 	memaddr = XPAR_MCB1_MPMC_BASEADDR;
		else memaddr = XPAR_MCB3_MPMC_BASEADDR;
		
      xil_printf("Starting MemoryTest for MCB:%d\r\n", cntrl);
       xil_printf("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)memaddr, 1024*1024*1, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
          xil_printf("PASSED!\r\n");
      }
      else {
          xil_printf("FAILED!\r\n");
      }
       xil_printf("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)memaddr, 2048*1024*1, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
          xil_printf("PASSED!\r\n");
      }
      else {
          xil_printf("FAILED!\r\n");
      }
       xil_printf("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)memaddr, 4096*1024*1, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
          xil_printf("PASSED!\r\n");
      }
      else {
          xil_printf("FAILED!\r\n");
      }
   }

int main (void) {

	while(1) {

		 xil_printf("-- CACHE OFF --\r\n");

		#if XPAR_MICROBLAZE_0_USE_DCACHE
			microblaze_disable_dcache();
			microblaze_invalidate_dcache();
		#endif

		#if XPAR_MICROBLAZE_0_USE_ICACHE
			microblaze_disable_icache();
			microblaze_invalidate_icache();
		#endif
		
		memtest(1);
		memtest(3);

		 xil_printf("-- CACHE ON --\r\n");

		#if XPAR_MICROBLAZE_0_USE_ICACHE
			microblaze_invalidate_icache();
			microblaze_enable_icache();
		#endif

		#if XPAR_MICROBLAZE_0_USE_DCACHE
			microblaze_invalidate_dcache();
			 microblaze_enable_dcache();
		#endif

		memtest(1);
		memtest(3);
	 
	}
   return 0;
	
}

