/*****************************************************************************
* Filename:          D:\Projekti\CAMOS\EDK\1st_system_v3/drivers/plb_singlewire_v2_00_a/src/plb_singlewire.h
* Version:           2.00.a
* Description:       plb_singlewire Driver Header File
* Date:              Wed Jun 30 17:34:33 2010 (by Create and Import Peripheral Wizard)
*****************************************************************************/

#ifndef PLB_SINGLEWIRE_H
#define PLB_SINGLEWIRE_H

/***************************** Include Files *******************************/

#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"

/************************** Constant Definitions ***************************/


/**
 * User Logic Slave Space Offsets
 * -- SLV_REG0 : user logic slave module register 0
 * -- SLV_REG1 : user logic slave module register 1
 * -- SLV_REG2 : user logic slave module register 2
 * -- SLV_REG3 : user logic slave module register 3
 */
#define PLB_SINGLEWIRE_USER_SLV_SPACE_OFFSET (0x00000000)
#define PLB_SINGLEWIRE_SLV_REG0_OFFSET (PLB_SINGLEWIRE_USER_SLV_SPACE_OFFSET + 0x00000000)
#define PLB_SINGLEWIRE_SLV_REG1_OFFSET (PLB_SINGLEWIRE_USER_SLV_SPACE_OFFSET + 0x00000004)
#define PLB_SINGLEWIRE_SLV_REG2_OFFSET (PLB_SINGLEWIRE_USER_SLV_SPACE_OFFSET + 0x00000008)
#define PLB_SINGLEWIRE_SLV_REG3_OFFSET (PLB_SINGLEWIRE_USER_SLV_SPACE_OFFSET + 0x0000000C)

/**
 * Software Reset Space Register Offsets
 * -- RST : software reset register
 */
#define PLB_SINGLEWIRE_SOFT_RST_SPACE_OFFSET (0x00000100)
#define PLB_SINGLEWIRE_RST_REG_OFFSET (PLB_SINGLEWIRE_SOFT_RST_SPACE_OFFSET + 0x00000000)

/**
 * Software Reset Masks
 * -- SOFT_RESET : software reset
 */
#define SOFT_RESET (0x0000000A)

/**************************** Type Definitions *****************************/


/***************** Macros (Inline Functions) Definitions *******************/

/**
 *
 * Write a value to a PLB_SINGLEWIRE register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the PLB_SINGLEWIRE device.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void PLB_SINGLEWIRE_mWriteReg(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Data)
 *
 */
#define PLB_SINGLEWIRE_mWriteReg(BaseAddress, RegOffset, Data) \
 	xil_io_out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

/**
 *
 * Read a value from a PLB_SINGLEWIRE register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the PLB_SINGLEWIRE device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note
 * C-style signature:
 * 	Xuint32 PLB_SINGLEWIRE_mReadReg(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define PLB_SINGLEWIRE_mReadReg(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (RegOffset))


/**
 *
 * Write/Read 32 bit value to/from PLB_SINGLEWIRE user logic slave registers.
 *
 * @param   BaseAddress is the base address of the PLB_SINGLEWIRE device.
 * @param   RegOffset is the offset from the slave register to write to or read from.
 * @param   Value is the data written to the register.
 *
 * @return  Data is the data from the user logic slave register.
 *
 * @note
 * C-style signature:
 * 	void PLB_SINGLEWIRE_mWriteSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Value)
 * 	Xuint32 PLB_SINGLEWIRE_mReadSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define PLB_SINGLEWIRE_mWriteSlaveReg0(BaseAddress, RegOffset, Value) \
 	xil_io_out32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG0_OFFSET) + (RegOffset), (Xuint32)(Value))
#define PLB_SINGLEWIRE_mWriteSlaveReg1(BaseAddress, RegOffset, Value) \
 	xil_io_out32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG1_OFFSET) + (RegOffset), (Xuint32)(Value))
#define PLB_SINGLEWIRE_mWriteSlaveReg2(BaseAddress, RegOffset, Value) \
 	xil_io_out32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG2_OFFSET) + (RegOffset), (Xuint32)(Value))
#define PLB_SINGLEWIRE_mWriteSlaveReg3(BaseAddress, RegOffset, Value) \
 	xil_io_out32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG3_OFFSET) + (RegOffset), (Xuint32)(Value))

#define PLB_SINGLEWIRE_mReadSlaveReg0(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG0_OFFSET) + (RegOffset))
#define PLB_SINGLEWIRE_mReadSlaveReg1(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG1_OFFSET) + (RegOffset))
#define PLB_SINGLEWIRE_mReadSlaveReg2(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG2_OFFSET) + (RegOffset))
#define PLB_SINGLEWIRE_mReadSlaveReg3(BaseAddress, RegOffset) \
 	xil_io_in32((BaseAddress) + (PLB_SINGLEWIRE_SLV_REG3_OFFSET) + (RegOffset))

/**
 *
 * Reset PLB_SINGLEWIRE via software.
 *
 * @param   BaseAddress is the base address of the PLB_SINGLEWIRE device.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void PLB_SINGLEWIRE_mReset(Xuint32 BaseAddress)
 *
 */
#define PLB_SINGLEWIRE_mReset(BaseAddress) \
 	xil_io_out32((BaseAddress)+(PLB_SINGLEWIRE_RST_REG_OFFSET), SOFT_RESET)

/************************** Function Prototypes ****************************/


/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the PLB_SINGLEWIRE instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */
XStatus PLB_SINGLEWIRE_SelfTest(void * baseaddr_p);

#endif /** PLB_SINGLEWIRE_H */
